import React, { useEffect, useState } from "react";
import { Button, IconButton, TextField, Tooltip } from "@mui/material";
import { useDispatch } from "react-redux";
import axios from "axios";
import { Grid } from "../../../../components/grid/Grid";
import { getRoleFromUrl } from "../../../../utils/getRoleFromUrl";
import ResponsiveTable from "../../../../components/responsive-table/ResponsiveTable";
import {
  LOADING_END,
  LOADING_START,
} from "../../../../lib/redux/slices/appSlice";
import { RiSearchLine } from "react-icons/ri";
import { useNavigate } from "react-router-dom";
import {
  ROUTE_ADMINX_DISPENSERS_KILLHOUSES,
  ROUTE_PROVINCE_DISPENSERS_KILLHOUSES,
  ROUTE_SUPER_ADMIN_DISPENSERS_KILLHOUSES,
} from "../../../../routes/routes";
import VisibilityIcon from "@mui/icons-material/Visibility";

export const ProvinceDispenserKillhouses = () => {
  const dispatch = useDispatch();
  const handleTextChange = (event) => {
    setTextValue(event.target.value);
  };
  const navigate = useNavigate();

  const [data, setData] = useState([]);
  const [totalRows, setTotalRows] = useState(0);
  const [perPage, setPerPage] = useState(10);
  const [textValue, setTextValue] = useState("");
  const [page, setPage] = useState(1);
  const [tableData, setTableData] = useState([]);

  const fetchApiData = async (page) => {
    let response;
    dispatch(LOADING_START());
    response = await axios.get(
      `kill-house-distribution-management/?search=filter&value=${textValue}&role=${getRoleFromUrl()}&page=${page}&page_size=${perPage}`
    );
    dispatch(LOADING_END());
    setData(response.data.results);
    setTotalRows(response.data.count);
  };

  const handlePageChange = (page) => {
    fetchApiData(page);
    setPage(page);
  };

  const handlePerRowsChange = (perRows) => {
    setPerPage(perRows);
    setPage(1);
  };

  //   const updateTable = () => {
  //     fetchApiData(page !== 0 ? page : 1);
  //   };

  useEffect(() => {
    const d = data?.map((item, i) => {
      return [
        page === 1 ? i + 1 : i + (perPage * page) / 2 + 1,
        `${item?.killHouseOperator?.user?.fullname} (${item?.killHouseOperator?.user?.mobile})`,
        item?.name,
        item?.killHouseOperator?.user?.city?.name,
        item?.distributionInfo?.stewards.toLocaleString(),
        item?.distributionInfo?.guilds.toLocaleString(),
        item?.distributionInfo?.totalDailyWeight.toLocaleString(),
        item?.distributionInfo?.forceDailyWeight.toLocaleString(),
        item?.distributionInfo?.optionalDailyWeight.toLocaleString(),
        item?.distributionInfo?.aveTotalDailyWeight.toLocaleString(),
        <Tooltip key={i} placement="left">
          <IconButton
            color="success"
            onClick={() => {
              navigate(
                getRoleFromUrl() === "AdminX"
                  ? ROUTE_ADMINX_DISPENSERS_KILLHOUSES +
                      "/" +
                      item?.key +
                      "/" +
                      item?.name
                  : getRoleFromUrl() === "SuperAdmin"
                  ? ROUTE_SUPER_ADMIN_DISPENSERS_KILLHOUSES +
                    "/" +
                    item?.key +
                    "/" +
                    item?.name
                  : getRoleFromUrl() === "ProvinceOperator"
                  ? ROUTE_PROVINCE_DISPENSERS_KILLHOUSES +
                    "/" +
                    item?.key +
                    "/" +
                    item?.name
                  : ROUTE_PROVINCE_DISPENSERS_KILLHOUSES +
                    "/" +
                    item?.key +
                    "/" +
                    item?.name
              );
            }}
          >
            <VisibilityIcon />
          </IconButton>
        </Tooltip>,
      ];
    });

    setTableData(d);
  }, [data]);

  useEffect(() => {
    fetchApiData(1);
  }, [dispatch, perPage]);

  const handleSubmit = async (event) => {
    event.preventDefault();
    dispatch(LOADING_START());

    try {
      const response = await axios.get(
        `kill-house-distribution-management/?role=${getRoleFromUrl()}&search=filter&value=${textValue}&page=${1}&page_size=${perPage}`
      );
      setData(response.data.results);
      setTotalRows(response.data.count);
      dispatch(LOADING_END());
    } catch (error) {
      console.error("Error fetching data:", error);
    }
  };

  return (
    <Grid container xs={12} justifyContent="center" alignItems="center" gap={2}>
      <Grid
        container
        xs={12}
        justifyContent="start"
        alignItems="center"
        gap={2}
      >
        <Grid>
          <form onSubmit={handleSubmit}>
            <TextField
              id="outlined-basic"
              size="small"
              label="جستجو"
              variant="outlined"
              style={{ width: 250 }}
              onChange={handleTextChange}
            />
            <Button
              // disabled={!textValue}
              type="submit"
              onClick={handleSubmit}
              endIcon={<RiSearchLine />}
            >
              جستجو
            </Button>
          </form>
        </Grid>
      </Grid>

      <ResponsiveTable
        data={tableData}
        columns={[
          "ردیف",
          "نام خریدار",
          "نام واحد",
          "شهرستان",
          "تعداد مباشر زیرمجموعه",
          "تعداد صنف زیرمجموعه",
          "کل وزن تعهد روزانه",
          "وزن تعهد روزانه/اجباری",
          "وزن تعهد روزانه/اختیاری",
          "میانگین وزن کشتار روزانه",
          "جزئیات",
        ]}
        handlePageChange={handlePageChange}
        totalRows={totalRows}
        page={page}
        perPage={perPage}
        handlePerRowsChange={handlePerRowsChange}
        title="مدیریت کشتارگاه ها"
      />
    </Grid>
  );
};
